//
//  Constants.swift
//

func removeNilValuedKeys<T>(dict:[T:AnyObject?])->[T:AnyObject] {
    var result:[T:AnyObject] = [:]
    for (key, value) in dict {
        if let value: AnyObject = value {
            result.updateValue(value, forKey: key)
        }
    }
    return result
}

func removeNilValuedKeys(dict:NSDictionary)->[String:AnyObject] {
    var result:[String:AnyObject] = [:]
    for (key, value) in dict {
        if let value: AnyObject = value where !(value is NSNull) {
            result.updateValue(value, forKey: key as! String)
        }
    }
    return result
}