//
//  NSDate+Rails.swift
//

import Foundation

extension NSDate {
    
    func railsFriendly() -> String {
        let format:NSDateFormatter = NSDateFormatter()
        format.dateFormat = "yyyy-MM-dd HH:mm:ss zzz"
        return format.stringFromDate(self)
    }
    
    class func fromRails(date:String) -> NSDate? {
        let dateFormatter = NSDateFormatter()
//    dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss Z" // expected date format: 2015-09-30 19:19:26 +0000
        dateFormatter.dateFormat = "yyyy-MM-dd'T'HH:mm:ss.SSSZ" // expected date format: 2015-10-12T17:46:00.386Z
        return dateFormatter.dateFromString(date)
    }
}